/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2015. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.xtools.rmps.web.deliver.CompareDeliverApplication");

dojo.require("jazz.app._AjaxApplication");

dojo.require("rmps.app.core.internal.WebUiInitializers");

dojo.require("dojo.i18n");

dojo.require("com.ibm.team.repository.web.client.internal.AdminClient");
var AdminClient = com.ibm.team.repository.web.client.internal.AdminClient;

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
var ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler;

dojo.requireLocalization("com.ibm.xtools.rmps.web.deliver",	"CompareAndDeliverApplication");


(function() {
	
	var messages = dojo.i18n.getLocalization("com.ibm.xtools.rmps.web.deliver",	"CompareAndDeliverApplication");

	dojo.declare("com.ibm.xtools.rmps.web.deliver.CompareDeliverApplication", jazz.app._AjaxApplication, {
		
		name: messages.appName,
		
		iconLarge: dojo.moduleUrl("rmps.app", "graphics/DM_24.png"),
	
		constructor: function(args) {
	
			this.ui.set("productIcon", this.iconLarge);
			this.config.usePageRegistry = false;
			dojo.style(this.ui.get("navbar").domNode, "display", "none");
	
			this.getUserRoles();
		},
		
		getUserRoles: function () {
			var srh= new ServiceResponseHandler(this, "authRequestPassed", "authRequestFailed");		
			AdminClient.getUserRoles(srh);
		},
		
		authRequestPassed: function(response) {
			if (response.userId) {
				dojo.setObject("com.ibm.team.repository.web.client.internal.AUTHENTICATED_USERID", response.userId);
				
				var user = response;
				this.config.user = {
					name: user.name,
					userId: user.userId,
					admin: user.isJazzAdmin,
					userSmallPreviewUrl: user.uri + "/smallPreview", //TODO should not be hard-coded, later should be in JTS Discovery Doc
					userProfileUrl: user.uri
				};
			}
			
			this.start();
		},
		
		authRequestFailed: function() {
			this.start();
		}	
	}); 

})();
