/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2014, 2015.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('com.ibm.xtools.rmps.web.deliver.shared.web.ui.picker.WorkspacePicker');

dojo.require('jazz.app.auth');
dojo.require("jazz.ui.MessageBox");
dojo.require('jazz.ui.SearchBox');
dojo.require("jazz.ui.StyledTable");
dojo.require('jazz.util.html');
dojo.require("jazz.ui.Toolbar");
dojo.require("jazz.ui.toolbar.TwoStateButton");
dojo.require("jazz.ui.RemoteChooserResponder");
dojo.require('jazz.ui.PaginationControl');
dojo.require("net.jazz.ajax.BootstrapProperties");

dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.layout.ContentPane");

dojo.require('dojo.NodeList-traverse');
dojo.require('dojo.i18n');

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.VvcCache");
dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.VvcConstants");
VvcConstants = com.ibm.xtools.rmps.web.deliver.shared.web.ui.VvcConstants;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.VvcUtils;

dojo.requireLocalization("com.ibm.xtools.rmps.web.deliver.shared.web.ui.picker", "WorkspacePickerMessages");

var hintHeight = "500";

(function ()
{
	
	function ignoreFieldKeyEvent(e)
	{
		if (e.ctrlKey || e.altKey) return true;

		switch(e.keyCode)
		{
		case dojo.keys.ENTER:
		case dojo.keys.ESCAPE:
		case dojo.keys.LEFT_ARROW:
		case dojo.keys.RIGHT_ARROW:
		case dojo.keys.TAB:
		case dojo.keys.SHIFT:
		case dojo.keys.ALT:
		case dojo.keys.CAPS_LOCK:
		case dojo.keys.PAGE_DOWN:
		case dojo.keys.PAGE_UP:
		case dojo.keys.LEFT_WINDOW:
		case dojo.keys.RIGHT_WINDOW:
		case dojo.keys.HOME:
		case dojo.keys.END:
		case dojo.keys.CTRL:
		case dojo.keys.F5:
			{
			return true;
			}
			
		default:
			return false;
		}
	}
	
	// TODO: This should use a utiliy method instead...
	function escapeHtml(html) {
		return html.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;');
	}
	
	/**
	 * Set "spaceUri" property to set the space uri you would like this dialog to constrain
	 * it's search results to, in the first argument of the constructor.
	 */
	dojo.declare('com.ibm.xtools.rmps.web.deliver.shared.web.ui.picker.WorkspacePicker', [dijit._Widget, dijit._Templated], {
			widgetsInTemplate: true,
			templatePath: dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver', 'shared/web/ui/picker/templates/WorkspacePicker.html'),
				
			// Hooks
			onCancel: null,
			onOk: null,
			onSelect: null,
			closeable: null,
			defaultSearchTerm: null,
			singleClickMode: null,
			_cache: null,
			_remoteFrame: null,
			
			_validTypes: null,
			_findParentsOfUri: null,
			_pureGlobalConfigurationsOnly: null,
			_mutableGlobalConfigurationsOnly: null,
			
			constructor: function (args) {
				
				var query = dojo.doc.location.search;
				if(query){
					var queryArgs = dojo.queryToObject(query.substring(1));
					// Convert boolean strings to real boolean values
					for(var arg in queryArgs){
						if(queryArgs[arg] === "true"){
							queryArgs[arg] = true;
						} else if(queryArgs[args] === "false"){
							queryArgs[arg] = false;
						}
					}
					dojo.mixin(args, queryArgs);
				}
				
				if (args) {
					if (args.spaceUri){
						this._spaceUri = args.spaceUri;
					}
					
					if (args.pureGlobalConfigurationsOnly) {
						this._pureGlobalConfigurationsOnly = args.pureGlobalConfigurationsOnly;
					}
					
					if (args.mutableGlobalConfigurationsOnly) {
						this._mutableGlobalConfigurationsOnly = args.mutableGlobalConfigurationsOnly;
					}
					
					if (args.findParentsOfUri) {
						this._findParentsOfUri = args.findParentsOfUri;
					}
										
					// CSV of types,  can be "workspace", "snapshot", or combination thereof
					if(args.validTypes){
						this._validTypes = args.validTypes;
					}
					
					if(args.queryOnLoad){
						var handle = dojo.connect(this, "startup", this, function(){
							this._runSearch(null, args.queryOnLoad)
							dojo.disconnect(handle);
						});
					}
					
					if(args.defaultSearchTerm){
						this.defaultSearchTerm = args.defaultSearchterm;
					}
					
					if(args.singleClickMode){
						this.singleClickMode === args.singleClickMode;
					}
					
					if(args.closeable === false){
						this.closeable = false;
						var handle = dojo.connect(this, "postCreate", dojo.hitch(this, function(){
							this.hideOkCancelButtons();
							dojo.disconnect(handle);
						}));
					} else{
						this.closeable = true;
					}
				}
				
				try {
					this._remoteFrame = new jazz.ui.RemoteChooserResponder();
					if (!this._remoteFrame.isPostMessageProtocol()) {
						this._remoteFrame = undefined;
					} 
				} catch (e) {
					//_remoteFrame will be undefined if it's not a supported message protocol
				}
				
				this.messages = dojo.i18n.getLocalization("com.ibm.xtools.rmps.web.deliver.shared.web.ui.picker", "WorkspacePickerMessages");
				this.spinnerUrl = dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver', 'shared/web/graphics/spinner.gif');
				this._iconSrc = dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver', 'shared/web/graphics/VVC.gif');

				
				var cacheArgs;
				
				if(this._pureGlobalConfigurationsOnly || this._mutableGlobalConfigurationsOnly){
					cacheArgs = {
						target: VvcUtils.getVvcUri() + "/client/globalConfiguration",
						bulkTarget: VvcUtils.getVvcUri() + "/client/globalConfigurations",
						storageKey: VvcConstants.GLOBAL_CONFIGURATIONS_CACHE_KEY
					}
				} else {
					cacheArgs = {
						storageKey: VvcConstants.CONFIGURATION_CACHE_KEY
					}
				}
				this._cache = new com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.VvcCache(cacheArgs);
				
			},
			
           cancel: function() {
				if (this._remoteFrame && this._remoteFrame.sendResponse) {
					var oslcResponse = {
						"oslc:results" : []
					};
					this._remoteFrame.sendResponse(dojo.toJson(oslcResponse));
				}
				this.onCancel && this.onCancel();
				this.destroyRecursive();
			},

			postCreate: function() {
				var self = this;
				if (this._remoteFrame) {

					var hintWidth = "100%";
					//by design, all URL parameters will be ignored if you are NOT in OSLC mode.
					if (location.search.length > 0) {
						var obj = dojo.queryToObject(location.search.substring(1));
						if (obj) {
							if (obj.hintHeight && obj.hintWidth) {
								hintHeight = obj.hintHeight;
								hintWidth = obj.hintWidth;
							}
							if (obj.pureGlobalConfigurationsOnly === "true") {
								this._pureGlobalConfigurationsOnly = true;
							} else if (obj.mutableGlobalConfigurationsOnly === "true") {
								this.mutableGlobalConfigurationsOnly = true;
							} else if (obj.contextUri) {
								this._spaceUri = obj.contextUri;
							}
						}
					}
					
					dojo.style(this._mainTable, "height", hintHeight+"px");
					dojo.style(this._picker, "width", hintWidth);
					dojo.style(this._picker, "height", hintHeight+"px");
				}
 				
				this._detailsOn = false;
				this._createResultsTable();
				
				// set initial focus
				if (this._searchBox) {
					var context = this;
					setTimeout(function() {
						if (context._searchBox) {
							context._searchBox.focus();
						}
					}, 100);
				}
				
				if (this._remoteFrame) {
					var size = dojo.position(this._picker, true);
					this._remoteFrame.sendResize(size.w + 15 + "px", size.h + "px");
				}
				
				this._pager.onNextClick = dojo.hitch(this, this.changePage);
				this._pager.onPreviousClick = dojo.hitch(this, this.changePage);
				
				this._updateCount(0);
			},
			
			getOtherComponentsHeight: function()
			{	
				var otherComponentsHeight =
					dojo.getMarginBox(this.configurationSpacePickerNode).h + 19 +
					dojo.getMarginBox(this._mainForm).h -
					dojo.getMarginBox(this._resultListScroller).h;
				return otherComponentsHeight;
			},

			_createResultsTable: function()
			{
				var table = new jazz.ui.StyledTable({
					   columns: [
					      {label: "", width: "34px", sortable: false},
					      {label: this.messages.name, width: "40%", sortable: false},
					      {label: this.messages.description, sortable: false}
					   ]
				});

				dojo.style(table.domNode, "width", "100%");
				dojo.style(table.domNode, "tableLayout", "fixed");
				this._resultsTable = table;
				this._resultsTableDiv.appendChild(table.domNode);
			},

			startup: function() {
				this.inherited(arguments);
				var self = this;
				window.setTimeout(function() {
					self._searchBox.focus();
				}, 1);
			},

			getSelected: function()
			{
				return this._selectedRow ? this._selectedRow.workspace : undefined;
			},
			
			_selectRow: function(row) {
				if (this._selectedRow) dojo.removeClass(this._selectedRow, 'selected');
				
				if (!row || !row.workspace)
					return;
				
				dojo.addClass(row, 'selected');
				this._selectedRow = row;

				this._submitButton.disabled = false;
			},

			_handleArrow: function(key) {
				if (!this._lastResult) return;

				var row;
				if (key == dojo.keys.DOWN_ARROW)
				{	
					if (!this._selectedRow) {
						// select first on arrow down if no selection
						row = this._getFirstRow(this._resultsTable.tbody);
					}
					else if (this._selectedRow.nextSibling && this._selectedRow.nextSibling.nodeName == 'TR') {
						row = this._selectedRow.nextSibling;
					}
				}
				else if (key == dojo.keys.UP_ARROW)
				{
					if (!this._selectedRow) {
						// select last on arrow up if no selection
						row = this._getFirstRow(this._resultsTable.tbody);
					}
					else if (this._selectedRow.previousSibling && this._selectedRow.previousSibling.nodeName == 'TR') {
						row = this._selectedRow.previousSibling;
					}
				}
				
				if(!row && this._selectedRow){
					row = this._selectedRow;
				}
				
				this._selectRow(row);
				if(this.onSelect && row){
					this.onSelect(row.workspace);
				}
			},

			_onFieldKeyDown: function(e) {
				if (ignoreFieldKeyEvent(e)) return;
				e.stopPropagation();
				var k = e.keyCode;
				
				if (k === dojo.keys.UP_ARROW
					|| k ===  dojo.keys.DOWN_ARROW) {
					dojo.stopEvent(e);
					this._handleArrow(k);
					return;
				}
				
				if(this.singleClickMode && k === dojo.keys.ENTER){
					dojo.stopEvent(e);
					this._onSubmit();
					return;
				}
				
				this._deselectAll();
				window.clearTimeout(this._pendingSearch);
				this._pendingSearch = window.setTimeout(dojo.hitch(this, this._runSearch, null), 400);
			},
			
			_onListKeyDown: function(e) {
				var k = e.keyCode;
				
				if (k == dojo.keys.UP_ARROW
					|| k ==  dojo.keys.DOWN_ARROW) {
					dojo.stopEvent(e);
					this._handleArrow(k);
					return;
				}
				
				if(this.singleClickMode && k === dojo.keys.ENTER){
					dojo.stopEvent(e);
					this._onSubmit();
					return;
				}
			}, 
			
			_onDblClickResource: function(e) {
				var row = e.target;

				if (e.target.nodeName != 'TR') {
					row = dojo.NodeList(e.target).closest('TR');
					if (!row) {
						console.warn('no list item found on click');
						return;
					}
					row = row[0];
				}

				dojo.stopEvent(e);
				this._selectRow(row);
				this._onSubmit();
			},

			_onClickResource: function(e) {
				var row = e.target;

				if (e.target.nodeName != 'TR') {
					row = dojo.NodeList(e.target).closest('TR');
					if (!row) {
						console.warn('no list item found on click');
						return;
					}
					row = row[0];
				}

				if (!dojo.hasClass(row, 'selected')) {
					this._deselectAll();
					this._selectRow(row);
				}
				
				if(this.singleClickMode){
					this._onSubmit(e);
				}
				
				if(this.onSelect && row){
					this.onSelect(row.workspace);
				}
			},
			
			_deselectAll: function()
			{
				if (this._selectedRow) {
					dojo.removeClass(this._selectedRow, 'selected');
					delete this._selectedRow;
				}

				this._submitButton.disabled = true;
			},
			
			_showLoading: function(show)
			{
				if (show) {
					this._loadingNode.style.display = '';
					this._noResultsNode.style.display = 'none';
				}
				else {
					this._loadingNode.style.display = 'none';
				}
			},

			_updateCount: function(count, pageNumber) {
				if (pageNumber !== undefined) {
					this._pager.startPage = (pageNumber - 1);
				}
				if (count == 0) {
					this._loadingNode.style.display = 'none';
					this._noResultsNode.style.display = '';
					this._noResultsNode.innerHTML = escapeHtml(this.messages.noResults);
					this._pager.setEnabled(false);
					this._pager.setTotal(0);
				} else {
					this._noResultsNode.style.display = 'none';
					this._pager.setEnabled(true);
					this._pager.setTotal(count);
				}				
			},
			
			uninitialize: function()
			{
				this.inherited(arguments);
			},

			/*
			 * The provided searchTerm overrides the user's input seach term.  If the picker
			 * was created using a defaultSearcTerm, then this will be used in the provided
			 * searchTerm or the user's searchTerm are undefined.
			 */
			_runSearch: function(e, /*Optional*/searchTerm, /*Optional*/pageNumber) {
				e && dojo.stopEvent(e);

				if (e && e.target == this._searchIcon) {
					this._searchBox.select();
				}

				window.clearTimeout(this._pendingSearch);
				
				var searchString;
				if(searchTerm){
					searchString = searchTerm;
				} else {
					searchString = dojo.trim(this._searchBox.value);
				}
				this.hideErrorMessage();
				
				delete this._lastResult;
				this._submitButton.disabled = true;
				this._showLoading(true);
				if (this._resultsTable)
					this._resultsTable.clearBody();
				
				if (searchString.length == 0) {
					if(this.defaultSearchTerm){
						searchString = this.defaultSearchTerm;
					} else {
						this._updateCount(0);
						return;
					}
				}

				var self = this;
				
				var content = {
					query: searchString
				};

				if (this._spaceUri) {
					content.space = this._spaceUri;
				}
				
				if(this._validTypes) {
					content.validTypes = this._validTypes ;
				}
				
				if (this._findParentsOfUri) {
					content.uri = this._findParentsOfUri;
				}
				
				if (pageNumber) {
					content.pageNumber = pageNumber;
				}
				else {
					content.pageNumber = 1;
				}
				content.pageSize = this.getSelectedPageSize();
				if (this._pager.increment == 0)
					this._pager.set('increment', content.pageSize);
				
				var params = dojo.objectToQuery(content);
				
				var serviceName;
				
				if (this._pureGlobalConfigurationsOnly || this._mutableGlobalConfigurationsOnly) {
					serviceName = "globalConfigurations/queryForTitle";
				} else if (this._findParentsOfUri) {
					serviceName = "globalConfigurations/findExpandedContexts";
				} else {
					serviceName = "WorkspacesQuery/query";
				}
				
				if (params) {
					params = "?" + params;
					if (this._mutableGlobalConfigurationsOnly) {
						params = params + "&mutable=true";
					}
				}
				
				var args = {
						handleAs: 'json',
						url: VvcUtils.getVvcUri() + "/" + serviceName + params, //$NON-NLS-1$
						"headers": { //$NON-NLS-1$
							"Content-Type" : "text/plain", //$NON-NLS-1$ //$NON-NLS-2$
						},
						handle: dojo.hitch(this, this._handleResponse)
				};
				
				var deferred = jazz.client.xhrGet(args);  
			},
			
			_handleResponse: function(response, ioargs) {
				this._showLoading(false);
				this._deselectAll();
				dojo.removeClass(this._searchIcon, 'loading');
				
				if (ioargs.xhr.status == 200)
				{
					if ("errorMessage" in response) //TODO: This is to be modified to whatever the error is supposed to be in the error json format
						this.displayErrorMessage(response.errorMessage);
					else  
						this._handleLoad(response);
				}
				else {
					console.log('error', response);
					this.displayErrorMessage("Invalid Response (Status:"+ioargs.xhr.status+"): "+ response.responseText);
				}
			},
			
			displayErrorMessage: function(errorMessage) 
			{
				var mb = new jazz.ui.MessageBox();
				mb.placeAt(dojo.byId("errorMessages"));
				mb.showMessage({summary: errorMessage, type: jazz.ui.MessageBox.STATUS_TYPES.ERROR});
				dojo.style("errorMessages", {display: ""});
			},
			
			hideErrorMessage: function() {
				dojo.empty("errorMessages");
				dojo.style("errorMessages", {display: "none"});
			},
			
			_handleLoad: function(results) {
				var uris = results.resultUris;
				var frag = document.createDocumentFragment();

				var missingIcon = dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver', 'shared/web/graphics/missing_icon.gif');
								
				var tr, td;
				this._cache.getAll(results.resultUris).then(dojo.hitch(this, function(configs){
					for(var configUrl in configs){
						var config = configs[configUrl];
						tr = document.createElement("tr");
						
						td = document.createElement("td");
						td.appendChild(dojo.create('img', {
							src: ((config.type === "globalConfiguration") || (this._spaceUri && config.spaceUri !== this._spaceUri)) ?
								dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver.shared.web', config.mutable ? 'graphics/globalconfiguration_mutable.gif' : 'graphics/globalconfiguration_immutable.gif') :
								this._getImgURL(config),
							height: '16',
							width: '16'
							}));
						tr.appendChild(td);
						
						td = document.createElement("td");
						var titleNode = document.createTextNode(config.title);
						td.appendChild(titleNode);
						tr.appendChild(td);
						
						td = document.createElement("td");
						td.innerHTML = jazz.util.html.escape(config.description);
						tr.appendChild(td);
					
						tr.workspace = config;
						frag.appendChild(tr);
	
						this._lastResult = config;
					
						this._resultsTable.tbody.appendChild(frag);
					}
				}));
				if (results.totalCount !== undefined) {
					totalCount = results.totalCount;
				}
				else {
					totalCount = results.resultUris.length;
				}
				this._updateCount(totalCount, results.pageNumber);
			},
			
			_getImgURL: function(workspace) {
				if (workspace.type == 'snapshot')
					return dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver', 'shared/web/graphics/snapshot.gif');
				else if (workspace.type == 'changeset')
				{	
					if (workspace.mutable)
						return dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver', 'shared/web/graphics/changeset.gif');
					else
						return dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver', 'shared/web/graphics/changeset_complete.gif');
				}
				return dojo.moduleUrl('com.ibm.xtools.rmps.web.deliver', 'shared/web/graphics/workspace.gif');
			},
			
			_onSubmit: function(e) {
				e && dojo.stopEvent(e);

				if (this._selectedRow) {
					if (this._remoteFrame) {
						var workspace = this._selectedRow.workspace;
						
						var oslcResponse = {
							"oslc:results" : [{
								"oslc:label" : workspace.title,
								"rdf:resource" : workspace.uri
							}]
						};
						
						this._remoteFrame.sendResponse(dojo.toJson(oslcResponse));

						return;
					}
					
					// There are selected result, so OK the dialog.
					// Can get selected result still with getter until this is destroyed.

					if (this.onOk) {
						// get off the DOM before destroy
						var workspace = this._selectedRow.workspace;
						var self = this;

						// Delay the callback until after the 'destroy' so that the dialog goes away
						window.setTimeout(function() {
							self.onOk(workspace);
						}, 1);
						
					}
					
					if(this.closeable != false){
						this.destroyRecursive();
					}
				}
			},
			
			_getFirstRow: function(table) {
				if(table.domNode){
					table = table.domNode;
				}
				var children = table.childNodes;
	
				for (var i = 0; i < children.length; i++) {
					var child = children[i];
					if (child.nodeName == 'TR')
						return child;
				}
				return null;
			},
			
			_getLastRow: function(table) {
				if(table.domNode){
					table = table.domNode;
				}
				var children = table.childNodes;
				for (var i = children.length - 1; i > -1; i--) {
					var child = children[i];
					if (child.nodeName == 'TR')
						return child;
				}
				return null;
			},
			
			hideOkCancelButtons: function(){
				dojo.addClass(this.okCancelButtons, "hidden");
				dojo.removeClass(this.okCancelButtons, "visible-block");
			},
			
			showOkCancelButtons: function(){
				dojo.addClass(this.okCancelButtons, "visible-block");
				dojo.removeClass(this.okCancelButtons, "hidden");
			},
			
			_onChangePageSize: function(){
				var pageSize = this.getSelectedPageSize();
				this._pager.set('increment', pageSize);
				this._runSearch();
			},
			
			getSelectedPageSize: function() {
				/* I'm leaving this code in here in case we want to bring back the page select 
				var index = this._pageSizeSelect.selectedIndex;
				if (index === -1) return 15; 

				var size = this._pageSizeSelect.options[index].value;
				return parseInt(size); */
				
				/* Calculate page size based on the table size so it never shows the scrollbar */
				return Math.floor((this._resultListScroller.clientHeight / 24)-1);
			},
			
			_getPageNumberForIndex: function(startIndex) {
				var page = Math.floor(startIndex / this._pager._getPageSize()) + 1;
				return page;
			},
			
			changePage: function(pager, start, end) {
				var pageNumber = this._getPageNumberForIndex(start);
				this._runSearch(null, null, pageNumber);
			}
		}
	);
})();
