/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013, 2014, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function DimensionUiNode(){
dojo.provide("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.DimensionAndEnumerationUiNodes");

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.ConfigurationUiNode");

dojo.declare("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.DimensionUiNode", com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.ConfigurationUiNode, {
           	
	constructor: function __dimensionUiNode(args, containerNode){
		this._includeLink = null;
		this._includeHover =  null;
	},
	
    _getContent: function __getContent(){
		var def = new dojo.Deferred();
		
		var contentNode = dojo.create("span");
		this._gc.destroys(contentNode);
		
		var dimensionTitle = this.messages[this._uri]
		if(!dimensionTitle){
			dimensionTitle = this._uri;
		}
		
		var titleNode = dojo.create("span", {
			"class": "titleNode",
			title: this._uri,
			innerHTML: this.messages[this._uri]
		});
		this._gc.destroys(titleNode);

		contentNode.appendChild(titleNode);
		
		dojo.empty(this.domNode);
		this.domNode.appendChild(contentNode);
		
		def.resolve();
		return def;
    }

});

dojo.declare("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.EnumerationUiNode", com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.ConfigurationUiNode, {
    
	_title: null,
	
	constructor: function __enumerationUiNode(args, containerNode){
		this._title = args.title;
		this._includeLink = null;
		this._includeHover =  null;
	},
	
	destroy: function __destroy(){
		this._title = null;
		this.inherited(arguments);
	},
	
    _getContent: function __getContent(){
		var def = new dojo.Deferred();
		
		var contentNode = dojo.create("span");
		this._gc.destroys(contentNode);
				
		var titleNode = dojo.create("span", {
			"class": "titleNode",
			innerHTML: this._title,
			title: this._uri
		});
		this._gc.destroys(titleNode);

		contentNode.appendChild(titleNode);
		
		dojo.empty(this.domNode);
		this.domNode.appendChild(contentNode);
		
		def.resolve();
		return def;
    }

});

})();
