/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2014, 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function PromptDialogContent(){
dojo.provide("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.PromptDialogContent");
dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.InfoContent");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.notifications.notifications.VvcNotificationFactory");
var NcFactory = com.ibm.xtools.rmps.web.deliver.shared.web.ui.notifications.notifications.VvcNotificationFactory;

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController");
var NotificationCenterController = com.ibm.xtools.rmps.web.deliver.shared.web.ui.notifications.notificationCenterController.VvcNotificationCenterController;

dojo.requireLocalization("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util", "PromptDialogContentMessages");
var Messages = dojo.i18n.getLocalization("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util", "InfoContentMessages");

dojo.require("com.ibm.xtools.rmps.web.deliver.shared.web.ui.gc.VvcGarbageCollector");
var GC = com.ibm.xtools.rmps.web.deliver.shared.web.ui.gc.VvcGarbageCollector;

dojo.declare("com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.PromptDialogContent", com.ibm.xtools.rmps.web.deliver.shared.web.ui.util.InfoContent, {
	
	message: null,
	inputBox: null,
	onInputChange: null,
	gc: null,
	
	setInfo: function __setInfo(){
        this.contentNode = this.message;
    },
    
    uninitialize: function __uninitialize(){
    	this.inherited(arguments);
    	this.gc.destroy();
    },

    postCreate: function __postCreate() {
    	this.gc = new GC();
    	var ncc = new NotificationCenterController();
    	this.informationCenterNode.appendChild(ncc.domNode);
    	
  	  var cancelButton = dojo.create("button", {
  		  id: "cancelButton",
  		  innerHTML: this.cancelMessage ? this.cancelMessage : Messages.buttonCancel
  	  }, this._buttonSection);
  	  dojo.addClass(cancelButton, "Button");
  	  dojo.connect(cancelButton, "onclick", dojo.hitch(this, this._handleCancel));
  	  
  	  dojo.attr(this.okCmd, "innerHTML", this.okMessage ? this.okMessage : Messages.buttonOK);
  	  
  	  var inputBox = new dijit.form.TextBox({
  		  value: this.defaultValue,
  		  placeholder: this.defaultValue,
  		  style: "width:100%;",
  		  onKeyUp : this.onInputChange ? dojo.hitch(this, this.onInputChange) : function __doNothing(){/* does nothing */},
  		  maxLength: this.maxLength ? this.maxLength : undefined,
  		  onKeyDown: dojo.hitch(this, this.onInputBoxKeyDown)
  	  });
  	  this.inputBox = inputBox;
  	  this.gc.destroys(inputBox);
  	  
  	  this.inputBox.focus();
  	  
  	  this._dialogContent.appendChild(this.inputBox.domNode);
    },
    
    onInputBoxKeyDown: function __onInputBoxKeyDown(event){
    	switch(event.keyCode) {
			case dojo.keys.ENTER:
				if (this.okFunction) {
		        	this.okFunction(this.inputBox.get("value"));
		        }
				this.onCancel();
				break;
			case dojo.keys.ESCAPE:
				this._handleCancel();
				break;	
    	}
    },
    
    setFocus: function __setFocus() {
    	this.inputBox.focus();
		this.inputBox.domNode.firstChild.firstChild.select()
    },
    
    _handleOk: function __handleOk(){
        if (this.okFunction) {
        	this.okFunction(this.inputBox.get("value"));
        }
        
        /*
         * TODO (amz): This seems like a bug waiting to happen.  This is what the super-class
         * does though...
         */ 
        this.onCancel();
    },
    
    _handleCancel: function __handleCancel(){
        this.onCancel();
        
        if (this.cancelFunction) {
        	this.cancelFunction();
        }
    }	    
    
});
})();
