/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
	
dojo.provide("rmps.app.ui.internal.application.NotAuthorized");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.ui.PlatformUI");

function workbenchRootNode(){
	// summary:
	//		helper to get workbench root node
	return net.jazz.ajax.ui.PlatformUI.getWorkbench().rootNode();
}

dojo.requireLocalization("rmps.app.ui.internal.application", "ApplicationMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.application", "ApplicationMessages");

dojo.declare("rmps.app.ui.internal.application.NotAuthorized", [dijit._Widget, dijit._Templated], {
	
	templateString: '<div>' +
					'   <div id="no-auth-content">' +
                    '      <div id="top"></div>' +
					'      <img id="lock-image" dojoAttachPoint="_lockImg"></img>' +
					'      <div id="no-auth-text" dojoAttachPoint="_textNode">' +
					'         <p dojoAttachPoint="_upperText">${upperText}</p>' +
					'         <p dojoAttachPoint="_middleText">${middleText}</p>' +
					'         <p dojoAttachPoint="_lowerText">${lowerTextPreLink} <a dojoAttachPoint="_anchor" id="login-failure-anchor">${linkText}</a> ${lowerTextPostLink}</p>' +
                    '         <div id="bottom"></div>' +
					'      </div>' +
					'   </div>' +
					'</div>',
	
	
	constructor: function() {
		//default text
		this.upperText = messages.labelNoLicense;
		this.middleText = messages.labelNoLicenseContact;
		this.lowerText = null;
		this.lowerTextPreLink = messages.labelReturnToLogin1;
		this.lowerTextPostLink = messages.labelReturnToLogin2;
		this.linkText = messages.labelReturnToLogin;
		this.linkOnClick = null;
		this.showIcon = true;
        this.icon = null;
	},
	
	postCreate: function() {
		this._lockImg.src = this.icon ? this.icon : dojo.moduleUrl("rmps.app", "graphics/icons/authorize_lock_obj32.gif");
		this._anchor.setAttribute("href", "javascript:{}");
		this.connect(this._anchor, "onclick", this.linkOnClick != null ? this.linkOnClick : "_doLogout");
		
        dojo.addClass(workbenchRootNode(), "com-ibm-dm-not-auth-container");
		workbenchRootNode().appendChild(this.domNode);		
		
		if (this._isEmpty(this.middleText)) {
			this._middleText.style.display = "none";
		}
		if (this._isEmpty(this.lowerTextPreLink) && this._isEmpty(this.lowerTextPostLink)) {
			this._lowerText.style.display = "none";
		}
		if (!this._isEmpty(this.lowerText)) {
			dojox.xml.parser.removeChildren(this._lowerText);
			this._lowerText.appendChild(document.createTextNode(this.lowerText));
		}
		if (!this.showIcon) {
			this._lockImg.style.display = "none";
		}
	},
	
	uninitialize: function() {
        dojo.removeClass(workbenchRootNode(), "com-ibm-dm-not-auth-container");		
	},
	
	_isEmpty: function(aString) {
		return (aString == null || dojo.trim(aString).length == 0);
	},
	
	_doLogout: function() {
		var daLogoutUrl = net.jazz.ajax.contextRoot() + "/service/com.ibm.team.repository.service.internal.ILogoutRestService";
		daLogoutUrl = daLogoutUrl + "?" + "redirectURL=" + encodeURIComponent(document.location);						
		document.location = daLogoutUrl;
	}
});

})();