/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2015.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
   
dojo.provide("rmps.app.ui.internal.changesets.DmChangeSetsExplorer");

dojo.require("com.ibm.team.repository.web.configurationManagement.notifications.CmNotificationFactory");
var CmNotificationFactory = com.ibm.team.repository.web.configurationManagement.notifications.CmNotificationFactory;

dojo.require("rmps.core.RootServices");
dojo.require("com.ibm.team.repository.web.configurationManagement.changesets.CmChangesetsExplorer");

dojo.require("rmps.app.ui.internal.util.CLMUtil");
var CLMUtil = rmps.app.ui.internal.util.CLMUtil;

dojo.require("rmps.app.ui.internal.changesets.DmChangeSetsExplorerTable");
var DmChangeSetsExplorerTable = rmps.app.ui.internal.changesets.DmChangeSetsExplorerTable;
	
dojo.declare("rmps.app.ui.internal.changesets.DmChangeSetsExplorer", [com.ibm.team.repository.web.configurationManagement.changesets.CmChangesetsExplorer], {
	
	// override buildTreeGridTableNode in com.ibm.team.repository.web.configurationManagement.changesets.CmChangesetsExplorer
	buildTreeGridTableNode: function(){
		this._gridTable = new DmChangeSetsExplorerTable();
		return this._gridTable.domNode;
	},
	
	onExpandRow: function(row, data, childOf){	
		var maxResults = 10;
		var chagesetId = CLMUtil.getIdFromUri(data.id); 
		var urlParams = {
			resources: true,
			maxEntries: maxResults
		};
		
		var getResourcesDeferred = jazz.client.xhrGet({
			url: rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "dm-changesets") + "/" + chagesetId + "?oslc_config.context=" + encodeURIComponent(this._configurationUri) + "&" + dojo.objectToQuery(urlParams)
		});
		
		var hideBusyIndicator = row.showBusyIndicator();
		getResourcesDeferred.then(dojo.hitch(this, function(results){
			if(results){
				var jsonResults = dojo.fromJson(results);
				if(jsonResults.length > 0){
					this._gridTable.addRows(jsonResults, row);
					hideBusyIndicator.resolve();
					return;
				}
			}
			
			// Show the "no results" node if there are no results
			this._gridTable.addRow({showNoResults: true}, row);
			hideBusyIndicator.resolve();
		}), dojo.hitch(this, function(error){
			hideBusyIndicator.resolve();
			CmNotificationFactory.createXhrError({xhrError: error, ioArgs: error.response.options.ioArgs}).dispatch();
		}));
	}	
});
}());
