/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2015, 2016. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/

(function DmMenuEntries() {
	dojo.provide("rmps.app.ui.internal.context.DmMenuEntries");

	dojo.requireLocalization("rmps.app.ui.internal.context", "DmMenuEntryMessages");
	var DmMenuEntryMessages = dojo.i18n.getLocalization("rmps.app.ui.internal.context", "DmMenuEntryMessages");

	dojo.require("com.ibm.team.repository.web.configurationManagement.CmTools");
	var CmTools = com.ibm.team.repository.web.configurationManagement.CmTools;

	dojo.require("com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory");
	var CmCacheFactory = com.ibm.team.repository.web.configurationManagement.cache.CmCacheFactory;

	dojo.require("com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider.CmMenuEntries");
	var CmMenuEntries = com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider.CmMenuEntries;

	dojo.require("com.ibm.team.repository.web.configurationManagement.CmConstants");
	var CmConstants = com.ibm.team.repository.web.configurationManagement.CmConstants;
	var CmConfigurationTypes = CmConstants.ConfigurationTypeLiterals;
	
	dojo.require("rmps.app.ui.internal.util.DmButtonFactory");
	var DmButtonFactory = rmps.app.ui.internal.util.DmButtonFactory;
	
    dojo.requireLocalization("com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider", "CmMenuEntryMessages");
    var CmMenuEntryMessages = dojo.i18n.getLocalization("com.ibm.team.repository.web.configurationManagement.contextBannerButton.menuProvider", "CmMenuEntryMessages"); 
	
	rmps.app.ui.internal.context.DmMenuEntries = {

			getEditDependenciesEntry: function __getCreateBaselineEntry(data, options){
				// Build up the default arguments for the button
				var args = {
						disabled: true,
						iconClass: "com-ibm-team-repository-configurationManagement-icons-baseline",
						title: DmMenuEntryMessages.EditDependencies,
						onClick: dojo.hitch(this, function __onClick(){
							window.location.href = CmTools.getContext().localConfigurationUri + "/dependencies";
						})
				};

				// Allow overriding of the default arguments.
				var argsMixin = dojo.mixin(args, options && options.args ? options.args : {});

				// Create the menu entry
				var entry = CmMenuEntries._makeMenuEntry(argsMixin, options);

				CmTools.addOnSetContextHandler(function __setContextCallback(newContext){
					entry.set('disabled', true);				
					if(newContext.localConfigurationUri){
						CmCacheFactory.getConfigurationCache().get(newContext.localConfigurationUri).then(function __getConf(data){
							entry.set('disabled', data.type !== CmConfigurationTypes.stream());				
						});
					}
				});

				return entry;
			},
			
			getAcceptMenuEntry: function __getAcceptMenuEntry(data, options){
				// Build up the default arguments for the button
				var args = {
					disabled: true,
					iconClass: "com-ibm-team-repository-configurationManagement-icons-baseline",
					title: CmMenuEntryMessages.acceptChanges,
					onClick: dojo.hitch(this, DmButtonFactory.onClickAccept, data, dojo.hitch(this, function (){
						return {
							targetUri: CmTools.getContext().localConfigurationUri
						};
					}))
				};

				// Allow overriding of the default arguments.
				var argsMixin = dojo.mixin(args, options && options.args ? options.args : {});
				
				// Create the menu entry
				var entry = CmMenuEntries._makeMenuEntry(argsMixin, options);
				
				CmTools.addOnSetContextHandler(function __setContextCallback(newContext){
					entry.set('disabled', true);				
					if(newContext.localConfigurationUri){
						 CmCacheFactory.getConfigurationCache().get(newContext.localConfigurationUri).then(function __getConf(data){
							entry.set('disabled', data.type !== CmConfigurationTypes.stream());				
						});
					}
				});
				
				return entry;
			},
			
			getDeliverMenuEntry: function __getDeliverMenuEntry(data, options){
				// Build up the default arguments for the button
				var args = {
					disabled: true,
					iconClass: "com-ibm-team-repository-configurationManagement-icons-baseline",
					title: CmMenuEntryMessages.deliverChanges,
					onClick: dojo.hitch(this, DmButtonFactory.onClickDeliver, data, dojo.hitch(this, function (){
						return {
							sourceUri: CmTools.getContext().localConfigurationUri
						};
					}))
				};

				// Allow overriding of the default arguments.
				var argsMixin = dojo.mixin(args, options && options.args ? options.args : {});
				
				// Create the menu entry
				var entry = CmMenuEntries._makeMenuEntry(argsMixin, options);
				
				CmTools.addOnSetContextHandler(function __setContextCallback(newContext){
					entry.set('disabled', true);				
					if(newContext.localConfigurationUri){
						 CmCacheFactory.getConfigurationCache().get(newContext.localConfigurationUri).then(function __getConf(data){
							entry.set('disabled', data.type !== CmConfigurationTypes.stream());				
						});
					}
				});
				
				return entry;
			}
	};
}());