/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2015.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
   
dojo.provide("rmps.app.ui.internal.history.HistoryPage");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.ui.PlatformUI");


dojo.require('dojo.i18n');
dojo.require("jazz.ui.Breadcrumbs");
dojo.require("rmps.app.ui.internal.history.HistoryWidget");

dojo.require("rmps.app.ui.internal.util.CLMUtil");
var CLMUtil = rmps.app.ui.internal.util.CLMUtil;

dojo.requireLocalization("rmps.app.ui.internal.history", "HistoryPageMessages");

(function ()
{
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	
	dojo.declare("rmps.app.ui.internal.history.HistoryPage", [dijit._Widget, dijit._Templated], {
	  
		widgetsInTemplate: true,
		
		templatePath: dojo.moduleUrl('rmps.app', 'ui/internal/history/templates/HistoryPage.html'),
	   
		constructor: function() {
			
			this.messages = dojo.i18n.getLocalization("rmps.app.ui.internal.history", "HistoryPageMessages");
		},
		
		postCreate: function(){
			var self = this;
			// Register the page action
			var ActionRegistry = PlatformUI.getWorkbench().getActionRegistry();
			ActionRegistry.registerAction("rmps.app.exploreHistory", this, "showHistory");
		},
	   
		showHistory: function() {
//			this._constructBreadcrumbs();
			this._constructHistoryWidgit();
		},
		
		_constructBreadcrumbs:function()
		{
			if (!this._breadcrumbs)
			{
				var parts = [];
				
				var explorerPageUri = CLMUtil.createLink("exploreConfigurations");
				segment = { label: this.messages.configurations, href : explorerPageUri };
				parts.push(segment);
				
				// add breadcrumb from query parameter
				var breadcrumb = CLMUtil.getRequestParmValue("breadcrumb");
				if (breadcrumb) {
					breadcrumb = decodeURIComponent(unescape(breadcrumb));
					segment = {
						label: breadcrumb, 
						href : 'javascript:history.back()'
					};
					parts.push(segment);
				}
		
				this._breadcrumbs = new jazz.ui.Breadcrumbs({segments: parts });
		
				this._breadcrumbs.placeAt(dojo.byId("breadcrumbs"));
			}
		},
		
		
		_constructHistoryWidgit: function() {
			if (!this._historyWidget)
			{
				this._historyWidget = new rmps.app.ui.internal.history.HistoryWidget();
				
			    /* append the new grid to the div */
			    this._mainDiv.appendChild(this._historyWidget.domNode);
			}
			else
				this._historyWidget.refresh();
		},

	    
	    uninitialize: function()
		{
	    	if (this._historyWidget) {
				this._historyWidget.destroyRecursive();
				delete this._historyWidget;
			}
	    	if (this._breadcrumbs) {
				this._breadcrumbs.destroyRecursive();
				delete this._breadcrumbs;
			}
		},

		
	})   
	})();
})();