/*
 * Licensed Materials - Property of IBM
 * Restricted Materials of IBM.  Reproduction, modification and redistribution are prohibited.
 * 
 * (c) Copyright IBM Corporation 2015, 2016.  
 * U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
(function() {
    dojo.provide("rmps.app.ui.internal.pages.DmBaselineEditor");
    
    dojo.require("com.ibm.team.repository.web.configurationManagement.editors.CmBaselineEditor");
    //dojo.require("com.ibm.rdm.web.pages._RmConfigurationEditorMixin");
    dojo.require("rmps.app.ui.internal.util.DmTabsBuilder");
    var DmTabsBuilder = rmps.app.ui.internal.util.DmTabsBuilder;
   
    var CmBaselineEditor = com.ibm.team.repository.web.configurationManagement.editors.CmBaselineEditor;
    //var _RmConfigurationEditorMixin = com.ibm.rdm.web.pages._RmConfigurationEditorMixin;
   
    // Summary:
    //      This is a simple subclass of the foundation Baseline editor. Just adds the project name
    //      and context button to the banner.
    dojo.declare("rmps.app.ui.internal.pages.DmBaselineEditor", 
                    [CmBaselineEditor], {

         // CmEditor will register this Action with the ActionRegistry...needs to match
         // the entry in com.ibm.rdm.web/plugin.xml                     
         editorAction: "rmps.app.editBaseline",
         workspacesViewer: null,
         _buildTabs: function __buildTabs(){
            var tabs = this.inherited(arguments);
            var canModify = (window.location.href && window.location.href.indexOf("canModify=true") > -1);
            tabs.push(DmTabsBuilder.buildDependenciesTab(this, canModify));
            return tabs;
         } 
                        
    });
}());