/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2015. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function DateTimeUiNode(){
dojo.provide("rmps.app.ui.internal.util.DateTimeUiNode");
dojo.require("dojo.date");
dojo.require("dojo.date.locale");

dojo.require("rmps.app.ui.internal.util.ConfigurationUiNode");

dojo.require("jazz.ui.ResourceLink");
var ResourceLink = jazz.ui.ResourceLink;

dojo.requireLocalization("rmps.app.ui.internal.util", "ConfigurationUiNodeMessages");
var Messages = dojo.i18n.getLocalization("rmps.app.ui.internal.util", "ConfigurationUiNodeMessages");

dojo.declare("rmps.app.ui.internal.util.DateTimeUiNode", rmps.app.ui.internal.util.ConfigurationUiNode, {
	
	_timestamp: null,
	_parentDomNode: null,
	
    constructor: function __dateTimeUiNode(args, containerNode){
   		this._timestamp = args.timestamp;
    	    	
    	if(containerNode){
    		this._parentDomNode = containerNode;
    	}
    	
		this._includeLink = false;
		this._includeHover = false;
    },
             
    _getContent: function ___getContent(){
		var def = new dojo.Deferred();
		dojo.removeAttr(this.domNode, "title");
		
		var dateObj = this._getDateObject(this._timestamp);
		dojo.empty(this.domNode);

		if(dateObj){
			var timestampText = dojo.date.locale.format(dateObj, {
				formatLength: 'medium'
			});//$NON-NLS-1$
			
			var contentNode = dojo.create("span", {
				innerHTML: timestampText
			});
			
			this.domNode.appendChild(contentNode);
		} else {
			this.domNode.appendChild(dojo.doc.createTextNode(Messages.invalidDate));
		}
		
		if(this._parentDomNode){
			this._parentDomNode.appendChild(this.domNode);
		}
		
		def.resolve();
		return def;
    },
    
    /**
     * Massages the input into a JS Date object.
     * 
     * @param input The input
     * 
     * @return A JS Date object.
     */
    _getDateObject: function __getDateObject(input){
    	
    	var date;
    	date = new Date();
    	date.setTime(Date.parse(input));
    	
    	return date;
    }

});

})();
