/*******************************************************************************
 * Licensed Materials - Property of IBM
 * © Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("rmps.app.ui.internal.util.ProjectAreaUiNode");

dojo.require("rmps.app.ui.internal.util.ConfigurationUiNode");

dojo.require("jazz.ui.ResourceLink");
var ResourceLink = jazz.ui.ResourceLink;

dojo.declare("rmps.app.ui.internal.util.ProjectAreaUiNode", rmps.app.ui.internal.util.ConfigurationUiNode, {
	
	_parentDomNode: null,
	_title: null,
	
    constructor: function(args, containerNode){
		this._uri = args.uri;
		this._title = args.title;
		
		this._includeHover = true;
		
		if(containerNode){
			this._parentDomNode = containerNode;
		}
    },
    
    postCreate: function __postCreate(){
		this.domNode = dojo.create("a", {
			title: this._title,
			href: this._uri,
			"class": "projectArea"
		});
		
		this.refresh();
    },
             
    _getContent: function(){
		var def = new dojo.Deferred();
		
		var iconClass = "projectArea";
		
		var contentNode = dojo.create("span", {
			"class": iconClass
		});
		
		var iconNode = dojo.create("span", {
			"class": "iconNode"
		});
		
		var titleNode = dojo.create("span", {
			"class": "titleNode",
			innerHTML: this._title
		});
		
		if(this._includeHover){
			this.getHover(this._uri, this._title , this.domNode);
		}
		
		contentNode.appendChild(iconNode);
		contentNode.appendChild(titleNode);
		
		dojo.empty(this.domNode);
		this.domNode.appendChild(contentNode);
		
		if(this._parentDomNode){
			this._parentDomNode.appendChild(this.domNode);
		}
		
		def.resolve();
		return def;
    },
    
    getHover: function(uri, title, titleNode){
		var resourceLink = new ResourceLink({
			uri: uri,
			label: title,
			around: titleNode
		});
    }
    
});

})();
