/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2015.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.views.CompactRenderingEditorInput");

dojo.require("rmps.core.util.ContextUtils");
dojo.require("dojox.encoding.digests.MD5");
dojo.require("dojo.date.locale");

var locale= dojo.date.locale;

var runningCount = 1;

dojo.declare("rmps.app.ui.internal.views.CompactRenderingEditorInput", null, {

	resourceInfo: null,
	resourceUri: null,
	diagramNode: null,
	isExpanded: null,
	projectArea: null,
	configuration: null,
	configurationName: null,
	
	constructor: function(args) {
		this.resourceUri = args.resourceUri;
		this.resourceInfo= args.resourceInfo;
		this.diagramNode= args.diagramNode;
		this.isExpanded= args.isExpanded;
		this.projectArea= args.projectArea;
		this.configuration= args.configuration;
		this.configurationName= args.configurationName;
	},
	
	load: function() {
		this._name = "New compact Rendering Diagram " + runningCount++;
		var deferred = new dojo.Deferred();
		deferred.callback(this);
		return deferred;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.resourceUri);
	},
	
	isLoaded: function() {
		return this.resourceInfo !== null;
	},
	
	getIconUri: function() {
		return this.resourceInfo.iconUri;
	},
	
	getImageUri: function(){
		var imageUri= net.jazz.ajax._contextRoot + "/diagrams/image?diagramUri=" + encodeURIComponent(this.resourceUri)
		+ "&" + Math.random();
		if(!this.getConfiguration()){
			return imageUri;
		}
		return rmps.core.util.ContextUtils.addContextParamaterToUrl(imageUri, this.getConfiguration());
	},
	
	getLongName: function() {
		return this.resourceInfo.longName;
	},
	
	getModificationTime: function() {
		return locale.format(this.resourceInfo.modificationTime, {formatLength: "medium"});
	},
	
	getDisplayType: function() {
		return this.resourceInfo.displayType;
	},
	
	getIsExpanded: function() {
		return this.isExpanded;
	},
	
	getResourceUri: function() {
		return this.resourceUri;
	},
	
	getProjectArea: function() {
		return this.projectArea;
	},
	
	getIsDiagram: function() {
		return  this.isExpanded;
	},
	
	getConfiguration: function() {
		return this.configuration;
	},
	
	getConfigurationName: function() {
		return this.configurationName;
	}
});

}());
